#include "myrand.h"

#define S (1<<8)

static long long a[S+10];

long long
rot(long long v, int r)
{
  return (((1ll<<r)-1)&(v>>r))|(v<<(64-r));
}

void
mix(int n)
{
  int i;
  while(n--) {
    for (i=4;i--;) a[S+i]=a[i];
    for (i=S;i--;) {
      long long x, y, z;
      x=a[i+1];
      y=a[i+2];
      z=a[i+4];
      a[i]+=rot(x,35)^rot(y,21)^rot(z,7);
    }
    for (i=4;i--;) a[S+i]=a[i];
    for (i=S;i--;) {
      long long x,y;
      x=a[i+1]&(S-1);
      y=(a[i+2]/S)&63;
      if (x!=i)
	a[i]^=rot(a[x],y);
      else
	a[i]+=i;
    }
  }
}

void
myinit()
{
  for(int i=S;i--;)
    a[0] = i+101;
  mix(1024);
}

int myrand()
{
  mix(1);
  return(07777777777&a[0]);
}
